Index: trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm
===================================================================
--- trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 68773)
+++ trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative286.asm	(revision 68932)
@@ -1114,18 +1114,18 @@
     db   'PCI: Unsupported function AX=%04X BX=%04X called', 00ah, 000h
 
-section CONST2 progbits vstart=0xd8e align=1 ; size=0x400 class=DATA group=DGROUP
-_bios_cvs_version_string:                    ; 0xf0d8e LB 0x18
-    db  'VirtualBox 5.2.0_BETA3', 000h, 000h
-_bios_prefix_string:                         ; 0xf0da6 LB 0x8
+section CONST2 progbits vstart=0xd8e align=1 ; size=0x3fe class=DATA group=DGROUP
+_bios_cvs_version_string:                    ; 0xf0d8e LB 0x16
+    db  'VirtualBox 5.2.0_RC1', 000h, 000h
+_bios_prefix_string:                         ; 0xf0da4 LB 0x8
     db  'BIOS: ', 000h, 000h
-_isotag:                                     ; 0xf0dae LB 0x6
+_isotag:                                     ; 0xf0dac LB 0x6
     db  'CD001', 000h
-_eltorito:                                   ; 0xf0db4 LB 0x18
+_eltorito:                                   ; 0xf0db2 LB 0x18
     db  'EL TORITO SPECIFICATION', 000h
-_drivetypes:                                 ; 0xf0dcc LB 0x28
+_drivetypes:                                 ; 0xf0dca LB 0x28
     db  046h, 06ch, 06fh, 070h, 070h, 079h, 000h, 000h, 000h, 000h, 048h, 061h, 072h, 064h, 020h, 044h
     db  069h, 073h, 06bh, 000h, 043h, 044h, 02dh, 052h, 04fh, 04dh, 000h, 000h, 000h, 000h, 04ch, 041h
     db  04eh, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-_scan_to_scanascii:                          ; 0xf0df4 LB 0x37a
+_scan_to_scanascii:                          ; 0xf0df2 LB 0x37a
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 01bh, 001h, 01bh, 001h, 01bh, 001h
     db  000h, 001h, 000h, 000h, 031h, 002h, 021h, 002h, 000h, 000h, 000h, 078h, 000h, 000h, 032h, 003h
@@ -1184,9 +1184,9 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 085h, 000h, 087h, 000h, 089h, 000h, 08bh, 000h, 000h
     db  000h, 086h, 000h, 088h, 000h, 08ah, 000h, 08ch, 000h, 000h
-_panic_msg_keyb_buffer_full:                 ; 0xf116e LB 0x20
+_panic_msg_keyb_buffer_full:                 ; 0xf116c LB 0x20
     db  '%s: keyboard input buffer full', 00ah, 000h
 
-  ; Padding 0x472 bytes at 0xf118e
-  times 1138 db 0
+  ; Padding 0x474 bytes at 0xf118c
+  times 1140 db 0
 
 section _TEXT progbits vstart=0x1600 align=1 ; size=0x8e18 class=CODE group=AUTO
@@ -1411,5 +1411,5 @@
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -2695,5 +2695,5 @@
     lea ax, [bp-03ah]                         ; 8d 46 c6
     call 05a02h                               ; e8 58 36
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -3446,5 +3446,5 @@
     cmp byte [bp+00ah], 002h                  ; 80 7e 0a 02
     jne short 02b52h                          ; 75 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -4280,5 +4280,5 @@
     cmp bh, 048h                              ; 80 ff 48
     jbe short 03292h                          ; 76 33
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5183,5 +5183,5 @@
     mov byte [es:bx], 000h                    ; 26 c6 07 00
     jmp near 0348ch                           ; e9 92 f9
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5281,5 +5281,5 @@
     cmp ax, strict word 0004ah                ; 3d 4a 00
     jne short 03be4h                          ; 75 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5386,5 +5386,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -5527,5 +5527,5 @@
     jnc short 03e62h                          ; 73 10
     mov al, byte [bp+di-00825h]               ; 8a 83 db f7
-    cmp al, byte [di+00daeh]                  ; 3a 85 ae 0d
+    cmp al, byte [di+00dach]                  ; 3a 85 ac 0d
     je short 03e4ch                           ; 74 f0
     mov ax, strict word 00005h                ; b8 05 00
@@ -5537,5 +5537,5 @@
     jnc short 03e7ch                          ; 73 10
     mov al, byte [bp+di-0081fh]               ; 8a 83 e1 f7
-    cmp al, byte [di+00db4h]                  ; 3a 85 b4 0d
+    cmp al, byte [di+00db2h]                  ; 3a 85 b2 0d
     je short 03e66h                           ; 74 f0
     mov ax, strict word 00006h                ; b8 06 00
@@ -5829,5 +5829,5 @@
     cmp ax, dx                                ; 39 d0
     je short 04212h                           ; 74 29
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6049,5 +6049,5 @@
     test al, al                               ; 84 c0
     je short 0446ch                           ; 74 37
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6146,5 +6146,5 @@
     mov word [bp+016h], bx                    ; 89 5e 16
     jmp near 04470h                           ; e9 38 ff
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6268,5 +6268,5 @@
     mov word [bp+016h], strict word 00007h    ; c7 46 16 07 00
     jmp near 04afbh                           ; e9 39 04
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6377,5 +6377,5 @@
     cmp byte [bp-018h], 000h                  ; 80 7e e8 00
     je short 04846h                           ; 74 53
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6682,10 +6682,10 @@
     je short 04b96h                           ; 74 21
     mov dx, strict word 00001h                ; ba 01 00
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 01923h                               ; e8 a0 cd
     imul dx, dx, strict byte 0000ah           ; 6b d2 0a
-    add dx, 00dcch                            ; 81 c2 cc 0d
+    add dx, 00dcah                            ; 81 c2 ca 0d
     push dx                                   ; 52
     push 00494h                               ; 68 94 04
@@ -6709,9 +6709,9 @@
     test al, al                               ; 84 c0
     je short 04bcch                           ; 74 1b
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 01923h                               ; e8 67 cd
-    push 00de0h                               ; 68 e0 0d
+    push 00ddeh                               ; 68 de 0d
     push 004a8h                               ; 68 a8 04
     push strict byte 00004h                   ; 6a 04
@@ -6721,25 +6721,25 @@
     test ah, ah                               ; 84 e4
     je short 04be0h                           ; 74 10
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 01923h                               ; e8 48 cd
-    push 00deah                               ; 68 ea 0d
+    push 00de8h                               ; 68 e8 0d
     jmp short 04bbfh                          ; eb df
     test bl, 080h                             ; f6 c3 80
     je short 04bf6h                           ; 74 11
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 01923h                               ; e8 33 cd
     push si                                   ; 56
-    push 00dd6h                               ; 68 d6 0d
+    push 00dd4h                               ; 68 d4 0d
     jmp short 04c05h                          ; eb 0f
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
     call 01923h                               ; e8 22 cd
     push si                                   ; 56
-    push 00dcch                               ; 68 cc 0d
+    push 00dcah                               ; 68 ca 0d
     push 004bdh                               ; 68 bd 04
     push strict byte 00004h                   ; 6a 04
@@ -6767,5 +6767,5 @@
     push dx                                   ; 52
     mov dx, ax                                ; 89 c2
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -6845,5 +6845,5 @@
     mov byte [bp-008h], al                    ; 88 46 f8
     mov byte [bp-00ah], al                    ; 88 46 f6
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7409,5 +7409,5 @@
     test al, al                               ; 84 c0
     jne short 0520fh                          ; 75 19
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7755,5 +7755,5 @@
     cmp byte [bp-00ah], 058h                  ; 80 7e f6 58
     jbe short 0559bh                          ; 76 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -7773,6 +7773,6 @@
     xor ah, ah                                ; 30 e4
     imul bx, ax, strict byte 0000ah           ; 6b d8 0a
-    mov dl, byte [bx+00dfah]                  ; 8a 97 fa 0d
-    mov ax, word [bx+00dfah]                  ; 8b 87 fa 0d
+    mov dl, byte [bx+00df8h]                  ; 8a 97 f8 0d
+    mov ax, word [bx+00df8h]                  ; 8b 87 f8 0d
     jmp near 05645h                           ; e9 90 00
     test AL, strict byte 004h                 ; a8 04
@@ -7781,6 +7781,6 @@
     xor ah, ah                                ; 30 e4
     imul bx, ax, strict byte 0000ah           ; 6b d8 0a
-    mov dl, byte [bx+00df8h]                  ; 8a 97 f8 0d
-    mov ax, word [bx+00df8h]                  ; 8b 87 f8 0d
+    mov dl, byte [bx+00df6h]                  ; 8a 97 f6 0d
+    mov ax, word [bx+00df6h]                  ; 8b 87 f6 0d
     jmp near 05645h                           ; e9 79 00
     mov al, byte [bp-00ch]                    ; 8a 46 f4
@@ -7802,14 +7802,14 @@
     xor ah, ah                                ; 30 e4
     imul bx, ax, strict byte 0000ah           ; 6b d8 0a
-    mov al, byte [bx+00dfch]                  ; 8a 87 fc 0d
+    mov al, byte [bx+00dfah]                  ; 8a 87 fa 0d
     mov dx, ax                                ; 89 c2
     mov al, byte [bp-00eh]                    ; 8a 46 f2
     test ax, dx                               ; 85 d0
     je short 0560eh                           ; 74 0a
+    mov dl, byte [bx+00df2h]                  ; 8a 97 f2 0d
+    mov ax, word [bx+00df2h]                  ; 8b 87 f2 0d
+    jmp short 05616h                          ; eb 08
     mov dl, byte [bx+00df4h]                  ; 8a 97 f4 0d
     mov ax, word [bx+00df4h]                  ; 8b 87 f4 0d
-    jmp short 05616h                          ; eb 08
-    mov dl, byte [bx+00df6h]                  ; 8a 97 f6 0d
-    mov ax, word [bx+00df6h]                  ; 8b 87 f6 0d
     shr ax, 008h                              ; c1 e8 08
     mov byte [bp-00ah], al                    ; 88 46 f6
@@ -7818,14 +7818,14 @@
     xor ah, ah                                ; 30 e4
     imul bx, ax, strict byte 0000ah           ; 6b d8 0a
-    mov al, byte [bx+00dfch]                  ; 8a 87 fc 0d
+    mov al, byte [bx+00dfah]                  ; 8a 87 fa 0d
     mov dx, ax                                ; 89 c2
     mov al, byte [bp-00eh]                    ; 8a 46 f2
     test ax, dx                               ; 85 d0
     je short 0563dh                           ; 74 0a
-    mov dl, byte [bx+00df6h]                  ; 8a 97 f6 0d
-    mov ax, word [bx+00df6h]                  ; 8b 87 f6 0d
-    jmp short 05645h                          ; eb 08
     mov dl, byte [bx+00df4h]                  ; 8a 97 f4 0d
     mov ax, word [bx+00df4h]                  ; 8b 87 f4 0d
+    jmp short 05645h                          ; eb 08
+    mov dl, byte [bx+00df2h]                  ; 8a 97 f2 0d
+    mov ax, word [bx+00df2h]                  ; 8b 87 f2 0d
     shr ax, 008h                              ; c1 e8 08
     mov byte [bp-00ah], al                    ; 88 46 f6
@@ -7834,5 +7834,5 @@
     test dl, dl                               ; 84 d2
     jne short 0566bh                          ; 75 16
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8034,5 +8034,5 @@
     mov word [bp+012h], dx                    ; 89 56 12
     jmp near 05855h                           ; e9 43 00
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8045,5 +8045,5 @@
     call 01966h                               ; e8 3a c1
     add sp, strict byte 00006h                ; 83 c4 06
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8438,5 +8438,5 @@
     test ax, ax                               ; 85 c0
     jne short 05c16h                          ; 75 26
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8469,5 +8469,5 @@
     cmp ax, dx                                ; 39 d0
     jbe short 05c74h                          ; 76 30
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8574,5 +8574,5 @@
     test dl, dl                               ; 84 d2
     je short 05dbbh                           ; 74 46
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8593,5 +8593,5 @@
     or ah, 00ch                               ; 80 cc 0c
     jmp near 05f01h                           ; e9 5c 01
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8698,5 +8698,5 @@
     mov word [bp+016h], ax                    ; 89 46 16
     jmp near 05dbfh                           ; e9 04 ff
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8711,5 +8711,5 @@
     add sp, strict byte 00008h                ; 83 c4 08
     jmp near 05dbbh                           ; e9 dd fe
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8801,5 +8801,5 @@
     mov word [bp+014h], strict word 00007h    ; c7 46 14 07 00
     jmp near 06400h                           ; e9 10 04
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8853,5 +8853,5 @@
     cmp dx, word [es:bx+036h]                 ; 26 3b 57 36
     jc short 060abh                           ; 72 23
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -8911,5 +8911,5 @@
     test dl, dl                               ; 84 d2
     je short 0618dh                           ; 74 51
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -9500,5 +9500,5 @@
     mov word [bp+00ch], ax                    ; 89 46 0c
     jmp near 0677fh                           ; e9 2b 00
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -9691,5 +9691,5 @@
     retf                                      ; cb
     jmp near 0677fh                           ; e9 49 fe
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -9731,5 +9731,5 @@
     or byte [bp+018h], 001h                   ; 80 4e 18 01
     jmp near 0677fh                           ; e9 d3 fd
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -9924,5 +9924,5 @@
     mov word [bp+014h], strict word 00003h    ; c7 46 14 03 00
     jmp short 06b65h                          ; eb b9
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -10700,5 +10700,5 @@
     je short 0738dh                           ; 74 0e
     push 008eeh                               ; 68 ee 08
-    push 0116eh                               ; 68 6e 11
+    push 0116ch                               ; 68 6c 11
     push strict byte 00007h                   ; 6a 07
     call 01966h                               ; e8 dc a5
@@ -10781,5 +10781,5 @@
     je short 0741eh                           ; 74 0e
     push 008f8h                               ; 68 f8 08
-    push 0116eh                               ; 68 6e 11
+    push 0116ch                               ; 68 6c 11
     push strict byte 00007h                   ; 6a 07
     call 01966h                               ; e8 4b a5
@@ -12290,5 +12290,5 @@
     cmp byte [bp+00ah], 002h                  ; 80 7e 0a 02
     jne short 081c7h                          ; 75 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -12512,5 +12512,5 @@
     cmp bx, 00200h                            ; 81 fb 00 02
     je short 083e9h                           ; 74 20
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -12697,5 +12697,5 @@
     mov word [es:bx+02ch], si                 ; 26 89 77 2c
     mov word [es:bx+032h], si                 ; 26 89 77 32
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -12753,5 +12753,5 @@
     inc byte [bp-00ch]                        ; fe 46 f4
     jmp near 086f5h                           ; e9 91 00
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -13888,5 +13888,5 @@
     cmp byte [bp+00ah], 002h                  ; 80 7e 0a 02
     jne short 09171h                          ; 75 1f
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -14346,5 +14346,5 @@
     lea ax, [bp-032h]                         ; 8d 46 ce
     call 05a02h                               ; e8 c2 c3
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -14874,5 +14874,5 @@
     hlt                                       ; f4
     jmp near 09b74h                           ; e9 2b 00
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -15200,5 +15200,5 @@
     mov word [es:bx], ax                      ; 26 89 07
     jmp short 09ea6h                          ; eb 2d
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da4h                            ; bb a4 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
@@ -17777,3 +17777,3 @@
 cpu_reset:                                   ; 0xffff0 LB 0x10
     jmp far 0f000h:0e05bh                     ; ea 5b e0 00 f0
-    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 097h
+    db  030h, 036h, 02fh, 032h, 033h, 02fh, 039h, 039h, 000h, 0fch, 0a8h