Index: trunk/src/VBox/Main/src-client/ConsoleImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 68986)
+++ trunk/src/VBox/Main/src-client/ConsoleImpl.cpp	(revision 68992)
@@ -3280,5 +3280,5 @@
 
 /* static */
-const char *Console::i_convertControllerTypeToDev(StorageControllerType_T enmCtrlType)
+const char *Console::i_storageControllerTypeToStr(StorageControllerType_T enmCtrlType)
 {
     switch (enmCtrlType)
@@ -3307,5 +3307,5 @@
 }
 
-HRESULT Console::i_convertBusPortDeviceToLun(StorageBus_T enmBus, LONG port, LONG device, unsigned &uLun)
+HRESULT Console::i_storageBusPortDeviceToLun(StorageBus_T enmBus, LONG port, LONG device, unsigned &uLun)
 {
     switch (enmBus)
@@ -3478,5 +3478,5 @@
     rc = pStorageController->COMGETTER(ControllerType)(&enmCtrlType);
     AssertComRC(rc);
-    pszDevice = i_convertControllerTypeToDev(enmCtrlType);
+    pszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
     StorageBus_T enmBus;
@@ -3656,5 +3656,5 @@
     rc = pStorageController->COMGETTER(ControllerType)(&enmCtrlType);
     AssertComRC(rc);
-    pszDevice = i_convertControllerTypeToDev(enmCtrlType);
+    pszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
     StorageBus_T enmBus;
@@ -3834,5 +3834,5 @@
     rc = pStorageController->COMGETTER(ControllerType)(&enmCtrlType);
     AssertComRC(rc);
-    pszDevice = i_convertControllerTypeToDev(enmCtrlType);
+    pszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
     StorageBus_T enmBus;
@@ -3948,5 +3948,5 @@
     hrc = pMediumAtt->COMGETTER(Port)(&lPort);                              H();
     hrc = pMediumAtt->COMGETTER(Type)(&lType);                              H();
-    hrc = Console::i_convertBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);  H();
+    hrc = Console::i_storageBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);  H();
 
 #undef H
@@ -4426,5 +4426,5 @@
         hrc = pStorageCtrl->COMGETTER(ControllerType)(&enmCtrlType);
         AssertComRC(hrc);
-        const char *pcszDevice = i_convertControllerTypeToDev(enmCtrlType);
+        const char *pcszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
         StorageBus_T enmBus;
@@ -4433,5 +4433,5 @@
 
         unsigned uLUN;
-        hrc = Console::i_convertBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
+        hrc = Console::i_storageBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
         AssertComRC(hrc);
 
@@ -4538,5 +4538,5 @@
             hrc = pStorageCtrl->COMGETTER(ControllerType)(&enmCtrlType);
             AssertComRC(hrc);
-            const char *pcszDevice = i_convertControllerTypeToDev(enmCtrlType);
+            const char *pcszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
             StorageBus_T enmBus;
@@ -4545,5 +4545,5 @@
 
             unsigned uLUN;
-            hrc = Console::i_convertBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
+            hrc = Console::i_storageBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
             AssertComRC(hrc);
 
@@ -4661,5 +4661,5 @@
             hrc = pStorageCtrl->COMGETTER(ControllerType)(&enmCtrlType);
             AssertComRC(hrc);
-            const char *pcszDevice = i_convertControllerTypeToDev(enmCtrlType);
+            const char *pcszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
             StorageBus_T enmBus;
@@ -4668,5 +4668,5 @@
 
             unsigned uLUN;
-            hrc = Console::i_convertBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
+            hrc = Console::i_storageBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
             AssertComRCReturnRC(hrc);
 
@@ -6197,5 +6197,5 @@
     rc = pStorageController->COMGETTER(ControllerType)(&enmCtrlType);
     AssertComRC(rc);
-    const char *pcszDevice = i_convertControllerTypeToDev(enmCtrlType);
+    const char *pcszDevice = i_storageControllerTypeToStr(enmCtrlType);
 
     StorageBus_T enmBus;
@@ -6210,5 +6210,5 @@
 
     unsigned uLUN;
-    rc = Console::i_convertBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
+    rc = Console::i_storageBusPortDeviceToLun(enmBus, lPort, lDev, uLUN);
     AssertComRCReturnRC(rc);
 
@@ -6344,5 +6344,5 @@
             throw rc;
 
-        const char *pcszDevice = i_convertControllerTypeToDev(enmController);
+        const char *pcszDevice = i_storageControllerTypeToStr(enmController);
 
         BOOL fBuiltinIOCache;