Index: trunk/include/VBox/Graphics/HGSMI.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMI.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMI.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - Host/Guest shared part.
Index: trunk/include/VBox/Graphics/HGSMIBase.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIBase.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIBase.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - buffer management.
@@ -6,20 +7,21 @@
  * Copyright (C) 2006-2017 Oracle Corporation
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
  *
- * The contents of this file may alternatively be used under the terms
- * of the Common Development and Distribution License Version 1.0
- * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
- * VirtualBox OSE distribution, in which case the provisions of the
- * CDDL are applicable instead of those of the GPL.
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
  *
- * You may elect to license modified versions of this file under the
- * terms and conditions of either the GPL or the CDDL or both.
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
+ * THE COPYRIGHT HOLDERS, AUTHORS AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM,
+ * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
+ * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
+ * USE OR OTHER DEALINGS IN THE SOFTWARE.
  */
 
Index: trunk/include/VBox/Graphics/HGSMIChSetup.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIChSetup.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIChSetup.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI), Host/Guest shared part.
Index: trunk/include/VBox/Graphics/HGSMIChannels.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIChannels.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIChannels.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  *
Index: trunk/include/VBox/Graphics/HGSMIContext.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIContext.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIContext.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - command contexts.
@@ -6,20 +7,21 @@
  * Copyright (C) 2006-2017 Oracle Corporation
  *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ * Permission is hereby granted, free of charge, to any person obtaining a
+ * copy of this software and associated documentation files (the "Software"),
+ * to deal in the Software without restriction, including without limitation
+ * the rights to use, copy, modify, merge, publish, distribute, sublicense,
+ * and/or sell copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following conditions:
  *
- * The contents of this file may alternatively be used under the terms
- * of the Common Development and Distribution License Version 1.0
- * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
- * VirtualBox OSE distribution, in which case the provisions of the
- * CDDL are applicable instead of those of the GPL.
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
  *
- * You may elect to license modified versions of this file under the
- * terms and conditions of either the GPL or the CDDL or both.
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
+ * THE COPYRIGHT HOLDERS, AUTHORS AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM,
+ * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
+ * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
+ * USE OR OTHER DEALINGS IN THE SOFTWARE.
  */
 
Index: trunk/include/VBox/Graphics/HGSMIDefs.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIDefs.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIDefs.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - shared part - types and defines.
Index: trunk/include/VBox/Graphics/HGSMIHostCmd.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIHostCmd.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIHostCmd.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - buffer management.
Index: trunk/include/VBox/Graphics/HGSMIMemAlloc.h
===================================================================
--- trunk/include/VBox/Graphics/HGSMIMemAlloc.h	(revision 68848)
+++ trunk/include/VBox/Graphics/HGSMIMemAlloc.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - Memory allocator.
Index: trunk/include/VBox/Graphics/VBoxCrHgsmi.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxCrHgsmi.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxCrHgsmi.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * Document me, pretty please.
Index: trunk/include/VBox/Graphics/VBoxUhgsmi.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxUhgsmi.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxUhgsmi.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * Document me, pretty please.
Index: trunk/include/VBox/Graphics/VBoxVideo.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideo.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxVideo.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VirtualBox Video interface.
Index: trunk/include/VBox/Graphics/VBoxVideo3D.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideo3D.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxVideo3D.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VirtualBox 3D common tooling
Index: trunk/include/VBox/Graphics/VBoxVideoGuest.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoGuest.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxVideoGuest.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VBox Host Guest Shared Memory Interface (HGSMI) - OS-independent guest structures.
Index: trunk/include/VBox/Graphics/VBoxVideoHost3D.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoHost3D.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxVideoHost3D.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VirtualBox 3D host inter-components interfaces
Index: trunk/include/VBox/Graphics/VBoxVideoIPRT.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoIPRT.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxVideoIPRT.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VirtualBox Video driver, common code - iprt and VirtualBox macros and definitions.
Index: trunk/include/VBox/Graphics/VBoxVideoVBE.h
===================================================================
--- trunk/include/VBox/Graphics/VBoxVideoVBE.h	(revision 68848)
+++ trunk/include/VBox/Graphics/VBoxVideoVBE.h	(revision 69015)
@@ -1,2 +1,3 @@
+/* $Id$ */
 /** @file
  * VirtualBox graphics card port I/O definitions