Index: trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/common/ctf/ctf_open.c
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/common/ctf/ctf_open.c	(revision 66829)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/common/ctf/ctf_open.c	(revision 69044)
@@ -290,5 +290,5 @@
 			else
 				pop[tp->ctt_type]++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case CTF_K_UNKNOWN:
 			vbytes = 0;
@@ -494,5 +494,5 @@
 				fp->ctf_ptrtab[
 				    CTF_TYPE_TO_INDEX(tp->ctt_type)] = id;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 
 		case CTF_K_VOLATILE:
@@ -503,5 +503,5 @@
 			if (err != 0 && err != ECTF_STRTAB)
 				return (err);
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 
 		default:
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_lex.l
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_lex.l	(revision 66829)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_lex.l	(revision 69044)
@@ -760,5 +760,5 @@
 		yypcb->pcb_hold = yypcb->pcb_list;
 		yypcb->pcb_list = NULL;
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 	case YYS_EXPR:
 		BEGIN(S0);
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_options.c
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_options.c	(revision 66829)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_options.c	(revision 69044)
@@ -642,17 +642,17 @@
 	case 'T':
 		mul *= 1024;
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 	case 'g':
 	case 'G':
 		mul *= 1024;
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 	case 'm':
 	case 'M':
 		mul *= 1024;
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 	case 'k':
 	case 'K':
 		mul *= 1024;
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 	default:
 		break;
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_parser.c
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_parser.c	(revision 66829)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/lib/libdtrace/common/dt_parser.c	(revision 69044)
@@ -578,5 +578,5 @@
 			dnp->dn_expr = NULL;
 		}
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 	case DT_NODE_OP2:
 		if (dnp->dn_left != NULL) {
@@ -1658,5 +1658,5 @@
 				if (ctf_type_size(dtt.dtt_ctfp, type) != 0)
 					break; /* proceed to declaring */
-				/*FALLTHRU*/
+				RT_FALL_THRU();
 			case CTF_K_FORWARD:
 				xyerror(D_DECL_INCOMPLETE,
@@ -1818,5 +1818,5 @@
 				    (64 - dt_node_type_size(cp) * NBBY);
 			}
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case DT_TOK_IPOS:
 			return (cp);
@@ -3612,5 +3612,5 @@
 		}
 
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 
 	case DT_TOK_DOT:
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/uts/common/dtrace/dtrace.c
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/uts/common/dtrace/dtrace.c	(revision 66829)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/uts/common/dtrace/dtrace.c	(revision 69044)
@@ -2419,5 +2419,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 
 		case DTRACESPEC_ACTIVEMANY:
@@ -4932,5 +4932,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDSB:
 			regs[rd] = (int8_t)dtrace_load8(regs[r1]);
@@ -4942,5 +4942,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDSH:
 			regs[rd] = (int16_t)dtrace_load16(regs[r1]);
@@ -4952,5 +4952,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDSW:
 			regs[rd] = (int32_t)dtrace_load32(regs[r1]);
@@ -4962,5 +4962,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDUB:
 			regs[rd] = dtrace_load8(regs[r1]);
@@ -4972,5 +4972,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDUH:
 			regs[rd] = dtrace_load16(regs[r1]);
@@ -4982,5 +4982,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDUW:
 			regs[rd] = dtrace_load32(regs[r1]);
@@ -4992,5 +4992,5 @@
 				break;
 			}
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DIF_OP_LDX:
 			regs[rd] = dtrace_load64(regs[r1]);
@@ -7017,10 +7017,10 @@
 		if ((c = *p++) == '\0')
 			return (0);
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 
 	default:
 		if (c != s1)
 			return (0);
-		/*FALLTHRU*/
+		RT_FALL_THRU();
 
 	case '?':
@@ -9973,5 +9973,5 @@
 			}
 
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DTRACEACT_LIBACT:
 		case DTRACEACT_DIFEXPR:
@@ -10010,5 +10010,5 @@
 			arg = DTRACE_USTACK_ARG(nframes, strsize);
 
-			/*FALLTHROUGH*/
+			RT_FALL_THRU();
 		case DTRACEACT_USTACK:
 			if (desc->dtad_kind != DTRACEACT_JSTACK &&
@@ -15235,5 +15235,5 @@
 		dhp = &help;
 		arg = (intptr_t)help.dofhp_dof;
-		/*FALLTHROUGH*/
+		RT_FALL_THRU();
 
 	case DTRACEHIOC_ADD: {
Index: trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/uts/intel/dtrace/fasttrap_isa.c
===================================================================
--- trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/uts/intel/dtrace/fasttrap_isa.c	(revision 66829)
+++ trunk/src/VBox/ExtPacks/VBoxDTrace/onnv/uts/intel/dtrace/fasttrap_isa.c	(revision 69044)
@@ -285,20 +285,20 @@
 		case FASTTRAP_PREFIX_SS:
 			seg++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case FASTTRAP_PREFIX_GS:
 			seg++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case FASTTRAP_PREFIX_FS:
 			seg++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case FASTTRAP_PREFIX_ES:
 			seg++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case FASTTRAP_PREFIX_DS:
 			seg++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case FASTTRAP_PREFIX_CS:
 			seg++;
-			/*FALLTHRU*/
+			RT_FALL_THRU();
 		case FASTTRAP_PREFIX_OPERAND:
 		case FASTTRAP_PREFIX_ADDRESS: