Index: trunk/src/VBox/GuestHost/OpenGL/packer/pack_bounds.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/packer/pack_bounds.c	(revision 68859)
+++ trunk/src/VBox/GuestHost/OpenGL/packer/pack_bounds.c	(revision 69046)
@@ -37,7 +37,7 @@
     switch ( len_aligned - len )
     {
-      case 3: *data_ptr++ = 0xff; /* FALLTHROUGH */
-      case 2: *data_ptr++ = 0xff; /* FALLTHROUGH */
-      case 1: *data_ptr++ = 0xff; /* FALLTHROUGH */
+      case 3: *data_ptr++ = 0xff; RT_FALL_THRU();
+      case 2: *data_ptr++ = 0xff; RT_FALL_THRU();
+      case 1: *data_ptr++ = 0xff; RT_FALL_THRU();
       default: break;
     }
Index: trunk/src/VBox/GuestHost/OpenGL/packer/pack_client.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/packer/pack_client.c	(revision 68859)
+++ trunk/src/VBox/GuestHost/OpenGL/packer/pack_client.c	(revision 69046)
@@ -109,6 +109,6 @@
                         crPackVertexAttrib4usvARB(attr, usPtr);
                         break;
-                    case 3: usv[2] = usPtr[2]; /* fall thru */
-                    case 2: usv[1] = usPtr[1]; /* fall thru */
+                    case 3: usv[2] = usPtr[2]; RT_FALL_THRU();
+                    case 2: usv[1] = usPtr[1]; RT_FALL_THRU();
                     case 1:
                         usv[0] = usPtr[0];
@@ -148,6 +148,6 @@
                         crPackVertexAttrib4ivARB(attr, iPtr);
                         break;
-                    case 3: iv[2] = iPtr[2]; /* fall thru */
-                    case 2: iv[1] = iPtr[1]; /* fall thru */
+                    case 3: iv[2] = iPtr[2]; RT_FALL_THRU();
+                    case 2: iv[1] = iPtr[1]; RT_FALL_THRU();
                     case 1:
                         iv[0] = iPtr[0];
@@ -187,6 +187,6 @@
                         crPackVertexAttrib4uivARB(attr, uiPtr);
                         break;
-                    case 3: uiv[2] = uiPtr[2]; /* fall thru */
-                    case 2: uiv[1] = uiPtr[1]; /* fall thru */
+                    case 3: uiv[2] = uiPtr[2]; RT_FALL_THRU();
+                    case 2: uiv[1] = uiPtr[1]; RT_FALL_THRU();
                     case 1:
                         uiv[0] = uiPtr[0];
@@ -244,6 +244,6 @@
                         crPackVertexAttrib4bvARB(attr, bPtr);
                         break;
-                    case 3: bv[2] = bPtr[2]; /* fall thru */
-                    case 2: bv[1] = bPtr[1]; /* fall thru */
+                    case 3: bv[2] = bPtr[2]; RT_FALL_THRU();
+                    case 2: bv[1] = bPtr[1]; RT_FALL_THRU();
                     case 1:
                         bv[0] = bPtr[0];
@@ -283,6 +283,6 @@
                         crPackVertexAttrib4ubvARB(attr, ubPtr);
                         break;
-                    case 3: ubv[2] = ubPtr[2]; /* fall thru */
-                    case 2: ubv[1] = ubPtr[1]; /* fall thru */
+                    case 3: ubv[2] = ubPtr[2]; RT_FALL_THRU();
+                    case 2: ubv[1] = ubPtr[1]; RT_FALL_THRU();
                     case 1:
                         ubv[0] = ubPtr[0];
Index: trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_buffer.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_buffer.c	(revision 68859)
+++ trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_buffer.c	(revision 69046)
@@ -195,5 +195,5 @@
                 break; /* OK */
 #endif
-        /* fall thru */
+        RT_FALL_THRU();
         default:
             crStateError(__LINE__, __FILE__, GL_INVALID_ENUM, "Invalid sfactor passed to glBlendFunc: %d", sfactor);
@@ -220,5 +220,5 @@
                 break; /* OK */
 #endif
-        /* fall thru */
+        RT_FALL_THRU();
         default:
             crStateError(__LINE__, __FILE__, GL_INVALID_ENUM, "Invalid dfactor passed to glBlendFunc: %d", dfactor);
@@ -291,5 +291,5 @@
                 break; /* OK */
 #endif
-        /* fall thru */
+        RT_FALL_THRU();
         default:
             crStateError(__LINE__, __FILE__, GL_INVALID_ENUM, "Invalid sfactorRGB passed to glBlendFuncSeparateEXT: %d", sfactorRGB);
@@ -317,5 +317,5 @@
                 break; /* OK */
 #endif
-        /* fall thru */
+        RT_FALL_THRU();
         default:
             crStateError(__LINE__, __FILE__, GL_INVALID_ENUM, "Invalid sfactorA passed to glBlendFuncSeparateEXT: %d", sfactorA);
@@ -345,5 +345,5 @@
                 break; /* OK */
 #endif
-        /* fall thru */
+        RT_FALL_THRU();
         default:
             crStateError(__LINE__, __FILE__, GL_INVALID_ENUM, "Invalid dfactorRGB passed to glBlendFuncSeparateEXT: %d", dfactorRGB);
@@ -373,5 +373,5 @@
                 break; /* OK */
 #endif
-        /* fall thru */
+        RT_FALL_THRU();
         default:
             crStateError(__LINE__, __FILE__, GL_INVALID_ENUM, "Invalid dfactorA passed to glBlendFuncSeparateEXT: %d", dfactorA);
Index: trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_lighting.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_lighting.c	(revision 68859)
+++ trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_lighting.c	(revision 69046)
@@ -533,5 +533,5 @@
 					l->ambient[0].b = param[2];
 					l->ambient[0].a = param[3];
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->ambient[1].r = param[0];
@@ -559,5 +559,5 @@
 					l->ambient[0].b = param[2];
 					l->ambient[0].a = param[3];
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->ambient[1].r = param[0];
@@ -570,5 +570,5 @@
 					return;
 			}
-			/* FALLTHROUGH! */
+			RT_FALL_THRU();
 		case GL_DIFFUSE :
 			switch (face)
@@ -585,5 +585,5 @@
 					l->diffuse[0].b = param[2];
 					l->diffuse[0].a = param[3];
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->diffuse[1].r = param[0];
@@ -611,5 +611,5 @@
 					l->specular[0].b = param[2];
 					l->specular[0].a = param[3];
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->specular[1].r = param[0];
@@ -637,5 +637,5 @@
 					l->emission[0].b = param[2];
 					l->emission[0].a = param[3];
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->emission[1].r = param[0];
@@ -663,5 +663,5 @@
 				case GL_FRONT_AND_BACK:
 					l->shininess[0] = *param;
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->shininess[1] = *param;
@@ -684,5 +684,5 @@
 					l->indexes[0][1] = (GLint) param[1];
 					l->indexes[0][2] = (GLint) param[2];
-					/* FALLTHROUGH! */
+					RT_FALL_THRU();
 				case GL_BACK:
 					l->indexes[1][0] = (GLint) param[0];
Index: trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_polygon.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_polygon.c	(revision 68859)
+++ trunk/src/VBox/GuestHost/OpenGL/state_tracker/state_polygon.c	(revision 69046)
@@ -128,5 +128,5 @@
         case GL_FRONT_AND_BACK:
             p->frontMode = mode;
-            /* fall thru */
+            RT_FALL_THRU();
         case GL_BACK:
             p->backMode = mode;